res = require "libs/res" -- "Screen Scaler Helper" module by Minh Ngo
HC  = require "libs/collider" 

require "modules/mouse"
require "modules/map"
require "modules/menu"
require "modules/player"
require "modules/keyboard"

gw, gh = love.graphics.getWidth(), love.graphics.getHeight()

function love.load()
  g = love.graphics
	res.set("nearest", gw /2, gh / 2, gw, gh)
	love.graphics.setDefaultFilter("nearest", "nearest")
  
  Collider = HC(100, on_collide)
  
	p = player:new()
	p.x = 21
	p.y = 21
	p.w = 21
	p.h = 21
	p.jumpSpeed = -400
  p.hopSpeed = -100
	p.runSpeed = 100
	p.col = Collider:addRectangle(p.x, p.y,21, 21)
    p.col.type = "player"
	gravity = 1800
	hasJumped = false
	delay = 120
	yFloor =250 
      
  --player.load()
	mouse.load()
	menu.load()
	map.load()
  
  ctiletbl = {}
  i = 1
    for x, y, tile in map.image("ground"):iterate() do
      
      print( string.format("Tile at (%d,%d) has an id of %d", x, y, tile.id) )
      ctiletbl[i] = Collider:addRectangle(x, y, 21, 21)
      ctiletbl[i].type = "tile"
      i = i + 1
    end
  
end

function love.update(dt)
  p:update(dt, gravity)
	mouse.update(dt)
  map.update(dt)
  keyboard.update(dt)
 
  -- for debug
  if p.x > 800 - p.w then p.x = 800 - p.w end
    if p.x < 0 then p.x = 0 end
    if p.y < 0 then p.y = 0 end
    if p.y > yFloor - p.h then
        p:hitFloor(yFloor)
  end
  
  Collider:update(dt) 
end

function love.draw()
	res.render(draw)
end

function draw() 
	map.drawBelowCamera()
 
  love.graphics.draw(
			p.sprite,
			p.x - p.sprite:getWidth() / 2,
			p.y - p.sprite:getHeight()
		)  
    	 
  map.drawAboveCamera()

	love.graphics.print("FPS = "..tostring(love.timer.getFPS( ).."\nGame resolution = "..gw.."x"..gh.."\nScreen resolution = ".. love.graphics.getWidth().."x"..love.graphics.getHeight()), 10, 10)
	mouse.draw()
end

function on_collide(dt, shape_a, shape_b)
  local playerCol
  if shape_a == p.col then
      playerCol = shape_b
  else
      playerCol = shape_a
  end
end

function PlayerCollision(shape)
    if shape.type == "player" then
          p.y = 10
        --p:hitFloor(130)
        --print("player is colliding with ground!")  
    end
end