mouse = {}

function mouse.load()
	love.mouse.setVisible(false)
	mouse.cursor = love.graphics.newImage("assets/menu/cursor.png")
	local switch = 0
end

function mouse.update(dt)
	-- restrict mouse movement when full screen
	mouse.x, mouse.y = res.gamePosition(love.mouse.getX(), love.mouse.getY())

	-- hide cursor if keyboard movement is used
	if love.keyboard.isDown("right", "left", "up", "down") then mouse.active = false end

	-- show cursor if mouse has moved
	if switch == 0 then
		mouse.xold, mouse.yold = res.gamePosition(love.mouse.getX(), love.mouse.getY())
		switch = 1
	else switch = 0 end
	if mouse.xold ~= mouse.x or mouse.yold ~= mouse.y then mouse.active = true end
end

function mouse.draw()
	if mouse.active then
		-- default cursor "hotspot" is 6, 6 pixels away from cursor top-left corner
		love.graphics.draw(mouse.cursor, math.floor(mouse.x) - 6, math.floor(mouse.y) - 6)
	end
end